/**********************************************************************
*  File:    COMPILER.H                                                *
*  Purpose: Comtrol Hostess i Programmers' Toolkit Compiler Differ-   *
*           ence Resolution Definitions (Host Version)                *
*  Date:    February 15, 1990                                         *
*  Author:  Howard D. Straus                                          *
*  Release: 1.00 - Original release                                   *
***********************************************************************
*                         COPYRIGHT NOTICE                            *
*=====================================================================*
*   Copyright 1990, 1991 by Howard D. Straus and Comtrol Corporation. *
*   All rights reserved.  Use or reproduction by any means of any     *
*   portion of this code contrary to the developers license agreement *
*   is expressly prohibited.                                          *
***********************************************************************/

typedef unsigned char   UTINY;
typedef unsigned int    UINT;
typedef unsigned long   ULONG;

#ifdef TURBO_C

extern  int     _wscroll;

#define ENABLE          enable
#define DISABLE     disable
#define OUTP        outportb
#define OUTPW       outport
#define INP                     inportb
#define INPW            inport
#define GET_VECTOR  getvect
#define SET_VECTOR  setvect
#define TEXTCOLOR       textcolor
#define TEXTBACKGROUND textbackground
#define TEXTPOSITION(row, col) gotoxy(col, row)
#define OUTTEXT         cputs
#define TEXT_INFO       text_info
#define WINDOW(r1, c1, r2, c2)          window(c1, r1, c2, r2)
#define INITGRAPH       initgraph(&gdriver, &gmode,"")
#define CLEARSCREEN     clrscr()
#define CLEARWINDOW clrscr()
#define GETTEXTROW() wherey()
#define GETTEXTCOL() wherex()
#define WRAPOFF()       (_wscroll=0)
#define WRAPON()        (_wscroll=1)
#define DELAY(x)        delay(x)

#else

void    wait(int);                  /* delay function */

#define ENABLE          _enable
#define DISABLE         _disable
#define OUTP        outp
#define OUTPW       outpw
#define INP                     inp
#define INPW            inpw
#define GET_VECTOR  _dos_getvect
#define SET_VECTOR  _dos_setvect
#define TEXTCOLOR(x)   _settextcolor((short)x)
#define TEXTBACKGROUND(x) _setbkcolor((long)x)
#define TEXTPOSITION(row, col) _settextposition(row, col)
#define OUTTEXT     _outtext
#define TEXT_INFO       rccoord
#define WINDOW(r1, c1, r2, c2)          _settextwindow(r1, c1, r2, c2)
#define HUGE        far
#define GETTEXTROW() (temp=_gettextposition(),temp.row)
#define GETTEXTCOL() (temp=_gettextposition(),temp.col)
#define INITGRAPH   _getvideoconfig(&vc)
#define CLEARSCREEN     _clearscreen(_GCLEARSCREEN)
#define CLEARWINDOW     _clearscreen(_GWINDOW)
#define WRAPOFF()       _wrapon(_GWRAPOFF)
#define WRAPON()        _wrapon(_GWRAPON)
#define DELAY(x)        wait(x)

#define MK_FP(s, o) ((void far *)(((ULONG)s<<16)|(UINT)o))

#define BLACK       0
#define BLUE        1
#define CYAN        3
#define LIGHTGRAY   7
#define YELLOW      14
#define WHITE       15

#endif
