/**********************************************************************
*  File:        TM.C                                                  *
*  Purpose:     COMTROL Hostess i Programmer's Toolkit Timer Services *
*  Written:     September 24, 1990                                    *
*  Author:      Howard D. Straus                                      *
*  Release:     1.00 - Original release                               *
***********************************************************************
*                         COPYRIGHT NOTICE                            *
*=====================================================================*
*   Copyright 1990, 1991 by Howard D. Straus and Comtrol Corporation. *
*   All rights reserved.  Use or reproduction by any means of any     *
*   portion of this code contrary to the developers license agreement *
*   is expressly prohibited.                                          *
***********************************************************************/

#include "compiler.h"

#include <dos.h>
#include <string.h>

#include "hostess.h"
#include "proto.h"
#include "externs.h"

/*
        variables used only in this module
*/
static  int     ticks = 0;      /* ticks until next second */

/*
        initialize timer for 0.10 second interrupt
*/
void
tm_ini()
{
        elapsed_ticks = 0;          /* clear ticks since time began */
        ticks = TICKS_PER_SECOND;   /* initialize ticks to next second */

        timer_start();              /* invoke assembly timer startup */

/*  OUTP(TIMER_CTL, ACTIVATE_TIMER); /* activate timer */
/*  OUTP(TIMER_PORT, TIME_CONST & 0xFF); /* set LSB of time count */
/*  OUTP(TIMER_PORT, TIME_CONST >> 8); /* set MSB of time count */
}


/*
        timer interrupt service routine
*/
void
tmr_isr()
{   char            ds[30];         /* space for diagnostic string */
        char            lf[10];         /* space for integer convert */

        elapsed_ticks++;                /* total elapsed ticks */

        if (--ticks <= 0)               /* if new second */
        {   ticks = TICKS_PER_SECOND;   /* reinitialize tick counter */
                ++curr_time;                /* bump time of day by 1 second */
                if (time_pending)
                        return;                                 /* do not send if pending time */
                if (curr_time > 0x100000L)  /* if host has set the time */
                        ho_sls(&lct[curr_line]); /* send it a status message */
#ifdef  VERBOSE
                ho_dig("Tick. //\n", 0);
#endif
        }
}



                                        /* ***** END OF FILE ***** */

